/* Automatically generated nanopb header */
/* Generated by nanopb-0.4.8-dev */

#ifndef PB_FK_APP_FK_APP_PB_H_INCLUDED
#define PB_FK_APP_FK_APP_PB_H_INCLUDED
#include <pb.h>

#if PB_PROTO_HEADER_VERSION != 40
#error Regenerate this file with the current version of nanopb generator.
#endif

/* Enum definitions */
typedef enum _fk_app_QueryFlags {
    fk_app_QueryFlags_QUERY_FLAGS_NONE = 0,
    fk_app_QueryFlags_QUERY_FLAGS_LOGS = 1
} fk_app_QueryFlags;

typedef enum _fk_app_QueryType {
    fk_app_QueryType_QUERY_NONE = 0,
    fk_app_QueryType_QUERY_CAPABILITIES = 1,
    fk_app_QueryType_QUERY_CONFIGURE_SENSOR = 2,
    fk_app_QueryType_QUERY_LIVE_DATA_POLL = 7,
    fk_app_QueryType_QUERY_SCHEDULES = 8,
    fk_app_QueryType_QUERY_CONFIGURE_SCHEDULES = 9,
    fk_app_QueryType_QUERY_FILES_SD = 10,
    fk_app_QueryType_QUERY_DOWNLOAD_FILE = 11,
    fk_app_QueryType_QUERY_ERASE_FILE = 12,
    fk_app_QueryType_QUERY_RESET = 13,
    fk_app_QueryType_QUERY_NETWORK_SETTINGS = 14,
    fk_app_QueryType_QUERY_CONFIGURE_NETWORK_SETTINGS = 15,
    fk_app_QueryType_QUERY_SCAN_MODULES = 16,
    fk_app_QueryType_QUERY_CONFIGURE_IDENTITY = 17,
    fk_app_QueryType_QUERY_STATUS = 18,
    fk_app_QueryType_QUERY_MODULE = 19,
    fk_app_QueryType_QUERY_METADATA = 20,
    fk_app_QueryType_QUERY_FORMAT = 21,
    fk_app_QueryType_QUERY_GET_READINGS = 22,
    fk_app_QueryType_QUERY_TAKE_READINGS = 23,
    fk_app_QueryType_QUERY_RECORDING_CONTROL = 24,
    fk_app_QueryType_QUERY_CONFIGURE = 25,
    fk_app_QueryType_QUERY_SCAN_NETWORKS = 26,
    fk_app_QueryType_QUERY_FILES_SPI = 27,
    fk_app_QueryType_QUERY_FILES_QSPI = 28
} fk_app_QueryType;

typedef enum _fk_app_ReplyType {
    fk_app_ReplyType_REPLY_NONE = 0,
    fk_app_ReplyType_REPLY_SUCCESS = 1,
    fk_app_ReplyType_REPLY_BUSY = 2,
    fk_app_ReplyType_REPLY_ERROR = 3,
    fk_app_ReplyType_REPLY_CAPABILITIES = 4,
    fk_app_ReplyType_REPLY_LIVE_DATA_POLL = 8,
    fk_app_ReplyType_REPLY_SCHEDULES = 9,
    fk_app_ReplyType_REPLY_FILES = 10,
    fk_app_ReplyType_REPLY_DOWNLOAD_FILE = 11,
    fk_app_ReplyType_REPLY_RESET = 12,
    fk_app_ReplyType_REPLY_NETWORK_SETTINGS = 13,
    fk_app_ReplyType_REPLY_IDENTITY = 14,
    fk_app_ReplyType_REPLY_STATUS = 15,
    fk_app_ReplyType_REPLY_MODULE = 16,
    fk_app_ReplyType_REPLY_METADATA = 17,
    fk_app_ReplyType_REPLY_READINGS = 18,
    fk_app_ReplyType_REPLY_NETWORKS = 19
} fk_app_ReplyType;

typedef enum _fk_app_DownloadFlags {
    fk_app_DownloadFlags_DOWNLOAD_FLAG_NONE = 0,
    fk_app_DownloadFlags_DOWNLOAD_FLAG_METADATA_PREPEND = 1,
    fk_app_DownloadFlags_DOWNLOAD_FLAG_METADATA_ONLY = 2
} fk_app_DownloadFlags;

typedef enum _fk_app_ModuleFlags {
    fk_app_ModuleFlags_MODULE_FLAG_NONE = 0,
    fk_app_ModuleFlags_MODULE_FLAG_INTERNAL = 1
} fk_app_ModuleFlags;

typedef enum _fk_app_SensorFlags {
    fk_app_SensorFlags_SENSOR_FLAG_NONE = 0
} fk_app_SensorFlags;

typedef enum _fk_app_ModuleQueryType {
    fk_app_ModuleQueryType_MODULE_QUERY_NONE = 0,
    fk_app_ModuleQueryType_MODULE_QUERY_STATUS = 1,
    fk_app_ModuleQueryType_MODULE_QUERY_CONFIGURE = 2,
    fk_app_ModuleQueryType_MODULE_QUERY_RESET = 3
} fk_app_ModuleQueryType;

typedef enum _fk_app_ModuleReplyType {
    fk_app_ModuleReplyType_MODULE_REPLY_NONE = 0,
    fk_app_ModuleReplyType_MODULE_REPLY_SUCCESS = 1,
    fk_app_ModuleReplyType_MODULE_REPLY_BUSY = 2,
    fk_app_ModuleReplyType_MODULE_REPLY_ERROR = 3
} fk_app_ModuleReplyType;

typedef enum _fk_app_UdpStatus {
    fk_app_UdpStatus_UDP_STATUS_ONLINE = 0,
    fk_app_UdpStatus_UDP_STATUS_BYE = 1
} fk_app_UdpStatus;

/* Struct definitions */
typedef struct _fk_app_QueryCapabilities {
    uint32_t version;
    uint32_t callerTime;
} fk_app_QueryCapabilities;

typedef struct _fk_app_LiveValue {
    bool valid;
    float value;
    float uncalibrated;
} fk_app_LiveValue;

typedef struct _fk_app_SensorCapabilities {
    uint32_t number;
    uint32_t module;
    pb_callback_t name;
    uint32_t frequency;
    pb_callback_t unitOfMeasure;
    /* v2 */
    pb_callback_t path;
    uint32_t flags;
    bool has_value;
    fk_app_LiveValue value;
    pb_callback_t uncalibratedUnitOfMeasure;
} fk_app_SensorCapabilities;

typedef struct _fk_app_ModuleHeader {
    uint32_t manufacturer;
    uint32_t kind;
    uint32_t version;
} fk_app_ModuleHeader;

typedef struct _fk_app_ModuleCapabilities {
    uint32_t position;
    pb_callback_t name;
    pb_callback_t sensors;
    /* v2 */
    pb_callback_t path;
    uint32_t flags;
    pb_callback_t id;
    bool has_header;
    fk_app_ModuleHeader header;
    pb_callback_t configuration;
} fk_app_ModuleCapabilities;

typedef struct _fk_app_Capabilities {
    uint32_t version;
    pb_callback_t deviceId;
    pb_callback_t name;
    pb_callback_t modules;
    pb_callback_t sensors;
} fk_app_Capabilities;

typedef struct _fk_app_NetworkInfo {
    pb_callback_t ssid;
    pb_callback_t password;
    bool create;
    bool preferred;
    bool keeping;
} fk_app_NetworkInfo;

typedef struct _fk_app_NetworkSettings {
    int32_t createAccessPoint;
    pb_callback_t networks;
    bool has_connected;
    fk_app_NetworkInfo connected;
    pb_callback_t macAddress;
    bool modifying;
    bool supportsUdp;
} fk_app_NetworkSettings;

typedef struct _fk_app_Firmware {
    pb_callback_t version;
    pb_callback_t build;
    pb_callback_t number;
    uint64_t timestamp;
    pb_callback_t hash;
    uint64_t logical_address;
    pb_callback_t name;
} fk_app_Firmware;

typedef struct _fk_app_Identity {
    pb_callback_t device;
    pb_callback_t stream;
    pb_callback_t deviceId;
    pb_callback_t firmware;
    pb_callback_t build;
    /* v2 */
    pb_callback_t name;
    pb_callback_t generationId;
    pb_callback_t number;
} fk_app_Identity;

typedef struct _fk_app_ConfigureSensorQuery {
    uint32_t id;
    uint32_t frequency;
} fk_app_ConfigureSensorQuery;

typedef struct _fk_app_LiveDataPoll {
    uint32_t interval;
} fk_app_LiveDataPoll;

typedef struct _fk_app_LiveDataSample {
    uint32_t sensor;
    uint64_t time;
    float value;
} fk_app_LiveDataSample;

typedef struct _fk_app_LiveData {
    pb_callback_t samples;
} fk_app_LiveData;

typedef struct _fk_app_File {
    uint32_t id;
    uint64_t time;
    uint64_t size;
    uint32_t version;
    pb_callback_t name;
    uint64_t maximum;
} fk_app_File;

typedef struct _fk_app_Files {
    pb_callback_t files;
} fk_app_Files;

typedef struct _fk_app_DownloadFile {
    uint32_t id;
    uint32_t offset;
    uint32_t length;
    uint32_t flags;
} fk_app_DownloadFile;

typedef struct _fk_app_EraseFile {
    uint32_t id;
} fk_app_EraseFile;

typedef struct _fk_app_FileData {
    uint32_t offset;
    pb_callback_t data;
    uint32_t size;
    uint32_t hash;
    uint32_t version;
    uint32_t id;
} fk_app_FileData;

typedef struct _fk_app_DeviceStatus {
    uint32_t uptime;
    float batteryPercentage;
    float batteryVoltage;
    uint32_t gpsHasFix;
    uint32_t gpsSatellites;
} fk_app_DeviceStatus;

typedef struct _fk_app_QueryModule {
    uint32_t id;
    uint32_t address;
    pb_callback_t message;
} fk_app_QueryModule;

typedef struct _fk_app_ModuleReply {
    uint32_t id;
    uint32_t address;
    pb_callback_t message;
} fk_app_ModuleReply;

typedef struct _fk_app_WireMessageQuery {
    fk_app_QueryType type;
    bool has_queryCapabilities;
    fk_app_QueryCapabilities queryCapabilities;
    bool has_configureSensor;
    fk_app_ConfigureSensorQuery configureSensor;
    bool has_liveDataPoll;
    fk_app_LiveDataPoll liveDataPoll;
    bool has_downloadFile;
    fk_app_DownloadFile downloadFile;
    bool has_eraseFile;
    fk_app_EraseFile eraseFile;
    bool has_networkSettings;
    fk_app_NetworkSettings networkSettings;
    bool has_identity;
    fk_app_Identity identity;
    bool has_module;
    fk_app_QueryModule module;
} fk_app_WireMessageQuery;

typedef struct _fk_app_Error {
    pb_callback_t message;
    uint32_t delay;
} fk_app_Error;

typedef struct _fk_app_WireMessageReply {
    fk_app_ReplyType type;
    pb_callback_t errors;
    bool has_capabilities;
    fk_app_Capabilities capabilities;
    bool has_liveData;
    fk_app_LiveData liveData;
    bool has_files;
    fk_app_Files files;
    bool has_fileData;
    fk_app_FileData fileData;
    bool has_networkSettings;
    fk_app_NetworkSettings networkSettings;
    bool has_identity;
    fk_app_Identity identity;
    bool has_status;
    fk_app_DeviceStatus status;
    bool has_module;
    fk_app_ModuleReply module;
} fk_app_WireMessageReply;

typedef struct _fk_app_Interval {
    uint64_t start;
    uint64_t end;
    uint32_t interval;
} fk_app_Interval;

typedef struct _fk_app_Schedule {
    pb_callback_t cron;
    uint32_t interval;
    uint32_t repeated;
    uint32_t duration;
    uint32_t jitter;
    pb_callback_t intervals;
} fk_app_Schedule;

typedef struct _fk_app_Schedules {
    bool modifying;
    bool has_readings;
    fk_app_Schedule readings;
    bool has_lora;
    fk_app_Schedule lora;
    bool has_network;
    fk_app_Schedule network;
    bool has_gps;
    fk_app_Schedule gps;
} fk_app_Schedules;

typedef struct _fk_app_HardwareStatus {
    char dummy_field;
} fk_app_HardwareStatus;

typedef struct _fk_app_GpsStatus {
    uint32_t fix;
    uint64_t time;
    uint32_t satellites;
    float longitude;
    float latitude;
    float altitude;
    uint32_t enabled;
} fk_app_GpsStatus;

typedef struct _fk_app_MemoryStatus {
    uint32_t sramAvailable;
    uint32_t programFlashAvailable;
    uint32_t extendedMemoryAvailable;
    uint32_t dataMemoryInstalled;
    uint32_t dataMemoryUsed;
    float dataMemoryConsumption;
    pb_callback_t firmware;
} fk_app_MemoryStatus;

typedef struct _fk_app_BatteryStatus {
    uint32_t voltage;
    uint32_t percentage;
} fk_app_BatteryStatus;

typedef struct _fk_app_SolarStatus {
    uint32_t voltage;
} fk_app_SolarStatus;

typedef struct _fk_app_PowerStatus {
    bool has_battery;
    fk_app_BatteryStatus battery;
    bool has_solar;
    fk_app_SolarStatus solar;
} fk_app_PowerStatus;

typedef struct _fk_app_Range {
    uint32_t start;
    uint32_t end;
} fk_app_Range;

typedef struct _fk_app_DownloadQuery {
    uint32_t stream;
    pb_callback_t ranges;
    pb_callback_t blocks;
} fk_app_DownloadQuery;

typedef struct _fk_app_LoraSettings {
    bool available;
    bool modifying;
    bool clearing;
    uint32_t frequencyBand;
    pb_callback_t deviceEui;
    pb_callback_t appKey;
    pb_callback_t joinEui;
    pb_callback_t deviceAddress;
    pb_callback_t networkSessionKey;
    pb_callback_t appSessionKey;
    bool verify;
} fk_app_LoraSettings;

typedef struct _fk_app_Location {
    bool modifying;
    float longitude;
    float latitude;
    uint64_t time;
} fk_app_Location;

typedef struct _fk_app_Recording {
    bool modifying;
    bool enabled;
    uint64_t startedTime;
    bool has_location;
    fk_app_Location location;
} fk_app_Recording;

typedef struct _fk_app_Status {
    uint32_t version;
    uint32_t uptime;
    bool has_identity;
    fk_app_Identity identity;
    bool has_hardware;
    fk_app_HardwareStatus hardware;
    bool has_power;
    fk_app_PowerStatus power;
    bool has_memory;
    fk_app_MemoryStatus memory;
    bool has_gps;
    fk_app_GpsStatus gps;
    bool has_schedules;
    fk_app_Schedules schedules;
    bool has_recording;
    fk_app_Recording recording;
    bool has_network;
    fk_app_NetworkSettings network;
    uint64_t time;
    bool has_firmware;
    fk_app_Firmware firmware;
    pb_callback_t logs;
} fk_app_Status;

typedef struct _fk_app_WifiTransmission {
    bool modifying;
    pb_callback_t url;
    pb_callback_t token;
    bool enabled;
} fk_app_WifiTransmission;

typedef struct _fk_app_Transmission {
    bool has_wifi;
    fk_app_WifiTransmission wifi;
} fk_app_Transmission;

typedef struct _fk_app_ListDirectory {
    pb_callback_t path;
    uint32_t page;
} fk_app_ListDirectory;

typedef struct _fk_app_HttpQuery {
    fk_app_QueryType type;
    bool has_identity;
    fk_app_Identity identity;
    bool has_recording;
    fk_app_Recording recording;
    bool has_schedules;
    fk_app_Schedules schedules;
    uint32_t flags;
    bool has_networkSettings;
    fk_app_NetworkSettings networkSettings;
    bool has_loraSettings;
    fk_app_LoraSettings loraSettings;
    uint64_t time;
    bool has_locate;
    fk_app_Location locate;
    bool has_transmission;
    fk_app_Transmission transmission;
    bool has_directory;
    fk_app_ListDirectory directory;
    uint32_t counter;
} fk_app_HttpQuery;

typedef struct _fk_app_DataStream {
    uint32_t id;
    uint64_t time;
    uint64_t size;
    uint32_t version;
    uint64_t block;
    pb_callback_t hash;
    pb_callback_t name;
    pb_callback_t path;
} fk_app_DataStream;

typedef struct _fk_app_LiveSensorReading {
    bool has_sensor;
    fk_app_SensorCapabilities sensor;
    float value;
    float uncalibrated;
    float factory;
    pb_callback_t adc;
} fk_app_LiveSensorReading;

typedef struct _fk_app_LiveModuleReadings {
    bool has_module;
    fk_app_ModuleCapabilities module;
    pb_callback_t readings;
} fk_app_LiveModuleReadings;

typedef struct _fk_app_LiveReadings {
    uint64_t time;
    pb_callback_t modules;
} fk_app_LiveReadings;

typedef struct _fk_app_DirectoryEntry {
    pb_callback_t name;
    pb_callback_t path;
    uint32_t size;
    bool directory;
} fk_app_DirectoryEntry;

typedef struct _fk_app_DirectoryListing {
    pb_callback_t path;
    pb_callback_t entries;
    uint32_t totalEntries;
} fk_app_DirectoryListing;

typedef struct _fk_app_NearbyNetwork {
    pb_callback_t ssid;
} fk_app_NearbyNetwork;

typedef struct _fk_app_NearbyNetworks {
    pb_callback_t networks;
} fk_app_NearbyNetworks;

typedef struct _fk_app_HttpReply {
    fk_app_ReplyType type;
    pb_callback_t errors;
    bool has_status;
    fk_app_Status status;
    bool has_networkSettings;
    fk_app_NetworkSettings networkSettings;
    pb_callback_t modules;
    pb_callback_t streams;
    pb_callback_t liveReadings;
    bool has_loraSettings;
    fk_app_LoraSettings loraSettings;
    bool has_schedules;
    fk_app_Schedules schedules;
    bool has_transmission;
    fk_app_Transmission transmission;
    bool has_listing;
    fk_app_DirectoryListing listing;
    bool has_nearbyNetworks;
    fk_app_NearbyNetworks nearbyNetworks;
    pb_callback_t events;
} fk_app_HttpReply;

typedef struct _fk_app_ModuleHttpQuery {
    fk_app_ModuleQueryType type;
    pb_callback_t errors;
    pb_callback_t configuration;
} fk_app_ModuleHttpQuery;

typedef struct _fk_app_ModuleHttpReply {
    fk_app_ModuleReplyType type;
    pb_callback_t errors;
    pb_callback_t configuration;
} fk_app_ModuleHttpReply;

typedef struct _fk_app_UdpMessage {
    pb_callback_t deviceId;
    fk_app_UdpStatus status;
    uint32_t counter;
    uint32_t port;
} fk_app_UdpMessage;


#ifdef __cplusplus
extern "C" {
#endif

/* Helper constants for enums */
#define _fk_app_QueryFlags_MIN fk_app_QueryFlags_QUERY_FLAGS_NONE
#define _fk_app_QueryFlags_MAX fk_app_QueryFlags_QUERY_FLAGS_LOGS
#define _fk_app_QueryFlags_ARRAYSIZE ((fk_app_QueryFlags)(fk_app_QueryFlags_QUERY_FLAGS_LOGS+1))

#define _fk_app_QueryType_MIN fk_app_QueryType_QUERY_NONE
#define _fk_app_QueryType_MAX fk_app_QueryType_QUERY_FILES_QSPI
#define _fk_app_QueryType_ARRAYSIZE ((fk_app_QueryType)(fk_app_QueryType_QUERY_FILES_QSPI+1))

#define _fk_app_ReplyType_MIN fk_app_ReplyType_REPLY_NONE
#define _fk_app_ReplyType_MAX fk_app_ReplyType_REPLY_NETWORKS
#define _fk_app_ReplyType_ARRAYSIZE ((fk_app_ReplyType)(fk_app_ReplyType_REPLY_NETWORKS+1))

#define _fk_app_DownloadFlags_MIN fk_app_DownloadFlags_DOWNLOAD_FLAG_NONE
#define _fk_app_DownloadFlags_MAX fk_app_DownloadFlags_DOWNLOAD_FLAG_METADATA_ONLY
#define _fk_app_DownloadFlags_ARRAYSIZE ((fk_app_DownloadFlags)(fk_app_DownloadFlags_DOWNLOAD_FLAG_METADATA_ONLY+1))

#define _fk_app_ModuleFlags_MIN fk_app_ModuleFlags_MODULE_FLAG_NONE
#define _fk_app_ModuleFlags_MAX fk_app_ModuleFlags_MODULE_FLAG_INTERNAL
#define _fk_app_ModuleFlags_ARRAYSIZE ((fk_app_ModuleFlags)(fk_app_ModuleFlags_MODULE_FLAG_INTERNAL+1))

#define _fk_app_SensorFlags_MIN fk_app_SensorFlags_SENSOR_FLAG_NONE
#define _fk_app_SensorFlags_MAX fk_app_SensorFlags_SENSOR_FLAG_NONE
#define _fk_app_SensorFlags_ARRAYSIZE ((fk_app_SensorFlags)(fk_app_SensorFlags_SENSOR_FLAG_NONE+1))

#define _fk_app_ModuleQueryType_MIN fk_app_ModuleQueryType_MODULE_QUERY_NONE
#define _fk_app_ModuleQueryType_MAX fk_app_ModuleQueryType_MODULE_QUERY_RESET
#define _fk_app_ModuleQueryType_ARRAYSIZE ((fk_app_ModuleQueryType)(fk_app_ModuleQueryType_MODULE_QUERY_RESET+1))

#define _fk_app_ModuleReplyType_MIN fk_app_ModuleReplyType_MODULE_REPLY_NONE
#define _fk_app_ModuleReplyType_MAX fk_app_ModuleReplyType_MODULE_REPLY_ERROR
#define _fk_app_ModuleReplyType_ARRAYSIZE ((fk_app_ModuleReplyType)(fk_app_ModuleReplyType_MODULE_REPLY_ERROR+1))

#define _fk_app_UdpStatus_MIN fk_app_UdpStatus_UDP_STATUS_ONLINE
#define _fk_app_UdpStatus_MAX fk_app_UdpStatus_UDP_STATUS_BYE
#define _fk_app_UdpStatus_ARRAYSIZE ((fk_app_UdpStatus)(fk_app_UdpStatus_UDP_STATUS_BYE+1))























#define fk_app_WireMessageQuery_type_ENUMTYPE fk_app_QueryType


#define fk_app_WireMessageReply_type_ENUMTYPE fk_app_ReplyType



















#define fk_app_HttpQuery_type_ENUMTYPE fk_app_QueryType









#define fk_app_HttpReply_type_ENUMTYPE fk_app_ReplyType

#define fk_app_ModuleHttpQuery_type_ENUMTYPE fk_app_ModuleQueryType

#define fk_app_ModuleHttpReply_type_ENUMTYPE fk_app_ModuleReplyType

#define fk_app_UdpMessage_status_ENUMTYPE fk_app_UdpStatus


/* Initializer values for message structs */
#define fk_app_QueryCapabilities_init_default    {0, 0}
#define fk_app_LiveValue_init_default            {0, 0, 0}
#define fk_app_SensorCapabilities_init_default   {0, 0, {{NULL}, NULL}, 0, {{NULL}, NULL}, {{NULL}, NULL}, 0, false, fk_app_LiveValue_init_default, {{NULL}, NULL}}
#define fk_app_ModuleHeader_init_default         {0, 0, 0}
#define fk_app_ModuleCapabilities_init_default   {0, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, 0, {{NULL}, NULL}, false, fk_app_ModuleHeader_init_default, {{NULL}, NULL}}
#define fk_app_Capabilities_init_default         {0, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}}
#define fk_app_NetworkInfo_init_default          {{{NULL}, NULL}, {{NULL}, NULL}, 0, 0, 0}
#define fk_app_NetworkSettings_init_default      {0, {{NULL}, NULL}, false, fk_app_NetworkInfo_init_default, {{NULL}, NULL}, 0, 0}
#define fk_app_Firmware_init_default             {{{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, 0, {{NULL}, NULL}, 0, {{NULL}, NULL}}
#define fk_app_Identity_init_default             {{{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}}
#define fk_app_ConfigureSensorQuery_init_default {0, 0}
#define fk_app_LiveDataPoll_init_default         {0}
#define fk_app_LiveDataSample_init_default       {0, 0, 0}
#define fk_app_LiveData_init_default             {{{NULL}, NULL}}
#define fk_app_File_init_default                 {0, 0, 0, 0, {{NULL}, NULL}, 0}
#define fk_app_Files_init_default                {{{NULL}, NULL}}
#define fk_app_DownloadFile_init_default         {0, 0, 0, 0}
#define fk_app_EraseFile_init_default            {0}
#define fk_app_FileData_init_default             {0, {{NULL}, NULL}, 0, 0, 0, 0}
#define fk_app_DeviceStatus_init_default         {0, 0, 0, 0, 0}
#define fk_app_QueryModule_init_default          {0, 0, {{NULL}, NULL}}
#define fk_app_ModuleReply_init_default          {0, 0, {{NULL}, NULL}}
#define fk_app_WireMessageQuery_init_default     {_fk_app_QueryType_MIN, false, fk_app_QueryCapabilities_init_default, false, fk_app_ConfigureSensorQuery_init_default, false, fk_app_LiveDataPoll_init_default, false, fk_app_DownloadFile_init_default, false, fk_app_EraseFile_init_default, false, fk_app_NetworkSettings_init_default, false, fk_app_Identity_init_default, false, fk_app_QueryModule_init_default}
#define fk_app_Error_init_default                {{{NULL}, NULL}, 0}
#define fk_app_WireMessageReply_init_default     {_fk_app_ReplyType_MIN, {{NULL}, NULL}, false, fk_app_Capabilities_init_default, false, fk_app_LiveData_init_default, false, fk_app_Files_init_default, false, fk_app_FileData_init_default, false, fk_app_NetworkSettings_init_default, false, fk_app_Identity_init_default, false, fk_app_DeviceStatus_init_default, false, fk_app_ModuleReply_init_default}
#define fk_app_Interval_init_default             {0, 0, 0}
#define fk_app_Schedule_init_default             {{{NULL}, NULL}, 0, 0, 0, 0, {{NULL}, NULL}}
#define fk_app_Schedules_init_default            {0, false, fk_app_Schedule_init_default, false, fk_app_Schedule_init_default, false, fk_app_Schedule_init_default, false, fk_app_Schedule_init_default}
#define fk_app_HardwareStatus_init_default       {0}
#define fk_app_GpsStatus_init_default            {0, 0, 0, 0, 0, 0, 0}
#define fk_app_MemoryStatus_init_default         {0, 0, 0, 0, 0, 0, {{NULL}, NULL}}
#define fk_app_BatteryStatus_init_default        {0, 0}
#define fk_app_SolarStatus_init_default          {0}
#define fk_app_PowerStatus_init_default          {false, fk_app_BatteryStatus_init_default, false, fk_app_SolarStatus_init_default}
#define fk_app_Status_init_default               {0, 0, false, fk_app_Identity_init_default, false, fk_app_HardwareStatus_init_default, false, fk_app_PowerStatus_init_default, false, fk_app_MemoryStatus_init_default, false, fk_app_GpsStatus_init_default, false, fk_app_Schedules_init_default, false, fk_app_Recording_init_default, false, fk_app_NetworkSettings_init_default, 0, false, fk_app_Firmware_init_default, {{NULL}, NULL}}
#define fk_app_Range_init_default                {0, 0}
#define fk_app_DownloadQuery_init_default        {0, {{NULL}, NULL}, {{NULL}, NULL}}
#define fk_app_Recording_init_default            {0, 0, 0, false, fk_app_Location_init_default}
#define fk_app_LoraSettings_init_default         {0, 0, 0, 0, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, 0}
#define fk_app_Location_init_default             {0, 0, 0, 0}
#define fk_app_WifiTransmission_init_default     {0, {{NULL}, NULL}, {{NULL}, NULL}, 0}
#define fk_app_Transmission_init_default         {false, fk_app_WifiTransmission_init_default}
#define fk_app_ListDirectory_init_default        {{{NULL}, NULL}, 0}
#define fk_app_HttpQuery_init_default            {_fk_app_QueryType_MIN, false, fk_app_Identity_init_default, false, fk_app_Recording_init_default, false, fk_app_Schedules_init_default, 0, false, fk_app_NetworkSettings_init_default, false, fk_app_LoraSettings_init_default, 0, false, fk_app_Location_init_default, false, fk_app_Transmission_init_default, false, fk_app_ListDirectory_init_default, 0}
#define fk_app_DataStream_init_default           {0, 0, 0, 0, 0, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}}
#define fk_app_LiveSensorReading_init_default    {false, fk_app_SensorCapabilities_init_default, 0, 0, 0, {{NULL}, NULL}}
#define fk_app_LiveModuleReadings_init_default   {false, fk_app_ModuleCapabilities_init_default, {{NULL}, NULL}}
#define fk_app_LiveReadings_init_default         {0, {{NULL}, NULL}}
#define fk_app_DirectoryEntry_init_default       {{{NULL}, NULL}, {{NULL}, NULL}, 0, 0}
#define fk_app_DirectoryListing_init_default     {{{NULL}, NULL}, {{NULL}, NULL}, 0}
#define fk_app_NearbyNetwork_init_default        {{{NULL}, NULL}}
#define fk_app_NearbyNetworks_init_default       {{{NULL}, NULL}}
#define fk_app_HttpReply_init_default            {_fk_app_ReplyType_MIN, {{NULL}, NULL}, false, fk_app_Status_init_default, false, fk_app_NetworkSettings_init_default, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, false, fk_app_LoraSettings_init_default, false, fk_app_Schedules_init_default, false, fk_app_Transmission_init_default, false, fk_app_DirectoryListing_init_default, false, fk_app_NearbyNetworks_init_default, {{NULL}, NULL}}
#define fk_app_ModuleHttpQuery_init_default      {_fk_app_ModuleQueryType_MIN, {{NULL}, NULL}, {{NULL}, NULL}}
#define fk_app_ModuleHttpReply_init_default      {_fk_app_ModuleReplyType_MIN, {{NULL}, NULL}, {{NULL}, NULL}}
#define fk_app_UdpMessage_init_default           {{{NULL}, NULL}, _fk_app_UdpStatus_MIN, 0, 0}
#define fk_app_QueryCapabilities_init_zero       {0, 0}
#define fk_app_LiveValue_init_zero               {0, 0, 0}
#define fk_app_SensorCapabilities_init_zero      {0, 0, {{NULL}, NULL}, 0, {{NULL}, NULL}, {{NULL}, NULL}, 0, false, fk_app_LiveValue_init_zero, {{NULL}, NULL}}
#define fk_app_ModuleHeader_init_zero            {0, 0, 0}
#define fk_app_ModuleCapabilities_init_zero      {0, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, 0, {{NULL}, NULL}, false, fk_app_ModuleHeader_init_zero, {{NULL}, NULL}}
#define fk_app_Capabilities_init_zero            {0, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}}
#define fk_app_NetworkInfo_init_zero             {{{NULL}, NULL}, {{NULL}, NULL}, 0, 0, 0}
#define fk_app_NetworkSettings_init_zero         {0, {{NULL}, NULL}, false, fk_app_NetworkInfo_init_zero, {{NULL}, NULL}, 0, 0}
#define fk_app_Firmware_init_zero                {{{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, 0, {{NULL}, NULL}, 0, {{NULL}, NULL}}
#define fk_app_Identity_init_zero                {{{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}}
#define fk_app_ConfigureSensorQuery_init_zero    {0, 0}
#define fk_app_LiveDataPoll_init_zero            {0}
#define fk_app_LiveDataSample_init_zero          {0, 0, 0}
#define fk_app_LiveData_init_zero                {{{NULL}, NULL}}
#define fk_app_File_init_zero                    {0, 0, 0, 0, {{NULL}, NULL}, 0}
#define fk_app_Files_init_zero                   {{{NULL}, NULL}}
#define fk_app_DownloadFile_init_zero            {0, 0, 0, 0}
#define fk_app_EraseFile_init_zero               {0}
#define fk_app_FileData_init_zero                {0, {{NULL}, NULL}, 0, 0, 0, 0}
#define fk_app_DeviceStatus_init_zero            {0, 0, 0, 0, 0}
#define fk_app_QueryModule_init_zero             {0, 0, {{NULL}, NULL}}
#define fk_app_ModuleReply_init_zero             {0, 0, {{NULL}, NULL}}
#define fk_app_WireMessageQuery_init_zero        {_fk_app_QueryType_MIN, false, fk_app_QueryCapabilities_init_zero, false, fk_app_ConfigureSensorQuery_init_zero, false, fk_app_LiveDataPoll_init_zero, false, fk_app_DownloadFile_init_zero, false, fk_app_EraseFile_init_zero, false, fk_app_NetworkSettings_init_zero, false, fk_app_Identity_init_zero, false, fk_app_QueryModule_init_zero}
#define fk_app_Error_init_zero                   {{{NULL}, NULL}, 0}
#define fk_app_WireMessageReply_init_zero        {_fk_app_ReplyType_MIN, {{NULL}, NULL}, false, fk_app_Capabilities_init_zero, false, fk_app_LiveData_init_zero, false, fk_app_Files_init_zero, false, fk_app_FileData_init_zero, false, fk_app_NetworkSettings_init_zero, false, fk_app_Identity_init_zero, false, fk_app_DeviceStatus_init_zero, false, fk_app_ModuleReply_init_zero}
#define fk_app_Interval_init_zero                {0, 0, 0}
#define fk_app_Schedule_init_zero                {{{NULL}, NULL}, 0, 0, 0, 0, {{NULL}, NULL}}
#define fk_app_Schedules_init_zero               {0, false, fk_app_Schedule_init_zero, false, fk_app_Schedule_init_zero, false, fk_app_Schedule_init_zero, false, fk_app_Schedule_init_zero}
#define fk_app_HardwareStatus_init_zero          {0}
#define fk_app_GpsStatus_init_zero               {0, 0, 0, 0, 0, 0, 0}
#define fk_app_MemoryStatus_init_zero            {0, 0, 0, 0, 0, 0, {{NULL}, NULL}}
#define fk_app_BatteryStatus_init_zero           {0, 0}
#define fk_app_SolarStatus_init_zero             {0}
#define fk_app_PowerStatus_init_zero             {false, fk_app_BatteryStatus_init_zero, false, fk_app_SolarStatus_init_zero}
#define fk_app_Status_init_zero                  {0, 0, false, fk_app_Identity_init_zero, false, fk_app_HardwareStatus_init_zero, false, fk_app_PowerStatus_init_zero, false, fk_app_MemoryStatus_init_zero, false, fk_app_GpsStatus_init_zero, false, fk_app_Schedules_init_zero, false, fk_app_Recording_init_zero, false, fk_app_NetworkSettings_init_zero, 0, false, fk_app_Firmware_init_zero, {{NULL}, NULL}}
#define fk_app_Range_init_zero                   {0, 0}
#define fk_app_DownloadQuery_init_zero           {0, {{NULL}, NULL}, {{NULL}, NULL}}
#define fk_app_Recording_init_zero               {0, 0, 0, false, fk_app_Location_init_zero}
#define fk_app_LoraSettings_init_zero            {0, 0, 0, 0, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, 0}
#define fk_app_Location_init_zero                {0, 0, 0, 0}
#define fk_app_WifiTransmission_init_zero        {0, {{NULL}, NULL}, {{NULL}, NULL}, 0}
#define fk_app_Transmission_init_zero            {false, fk_app_WifiTransmission_init_zero}
#define fk_app_ListDirectory_init_zero           {{{NULL}, NULL}, 0}
#define fk_app_HttpQuery_init_zero               {_fk_app_QueryType_MIN, false, fk_app_Identity_init_zero, false, fk_app_Recording_init_zero, false, fk_app_Schedules_init_zero, 0, false, fk_app_NetworkSettings_init_zero, false, fk_app_LoraSettings_init_zero, 0, false, fk_app_Location_init_zero, false, fk_app_Transmission_init_zero, false, fk_app_ListDirectory_init_zero, 0}
#define fk_app_DataStream_init_zero              {0, 0, 0, 0, 0, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}}
#define fk_app_LiveSensorReading_init_zero       {false, fk_app_SensorCapabilities_init_zero, 0, 0, 0, {{NULL}, NULL}}
#define fk_app_LiveModuleReadings_init_zero      {false, fk_app_ModuleCapabilities_init_zero, {{NULL}, NULL}}
#define fk_app_LiveReadings_init_zero            {0, {{NULL}, NULL}}
#define fk_app_DirectoryEntry_init_zero          {{{NULL}, NULL}, {{NULL}, NULL}, 0, 0}
#define fk_app_DirectoryListing_init_zero        {{{NULL}, NULL}, {{NULL}, NULL}, 0}
#define fk_app_NearbyNetwork_init_zero           {{{NULL}, NULL}}
#define fk_app_NearbyNetworks_init_zero          {{{NULL}, NULL}}
#define fk_app_HttpReply_init_zero               {_fk_app_ReplyType_MIN, {{NULL}, NULL}, false, fk_app_Status_init_zero, false, fk_app_NetworkSettings_init_zero, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, false, fk_app_LoraSettings_init_zero, false, fk_app_Schedules_init_zero, false, fk_app_Transmission_init_zero, false, fk_app_DirectoryListing_init_zero, false, fk_app_NearbyNetworks_init_zero, {{NULL}, NULL}}
#define fk_app_ModuleHttpQuery_init_zero         {_fk_app_ModuleQueryType_MIN, {{NULL}, NULL}, {{NULL}, NULL}}
#define fk_app_ModuleHttpReply_init_zero         {_fk_app_ModuleReplyType_MIN, {{NULL}, NULL}, {{NULL}, NULL}}
#define fk_app_UdpMessage_init_zero              {{{NULL}, NULL}, _fk_app_UdpStatus_MIN, 0, 0}

/* Field tags (for use in manual encoding/decoding) */
#define fk_app_QueryCapabilities_version_tag     1
#define fk_app_QueryCapabilities_callerTime_tag  2
#define fk_app_LiveValue_valid_tag               1
#define fk_app_LiveValue_value_tag               2
#define fk_app_LiveValue_uncalibrated_tag        3
#define fk_app_SensorCapabilities_number_tag     1
#define fk_app_SensorCapabilities_module_tag     2
#define fk_app_SensorCapabilities_name_tag       3
#define fk_app_SensorCapabilities_frequency_tag  4
#define fk_app_SensorCapabilities_unitOfMeasure_tag 5
#define fk_app_SensorCapabilities_path_tag       6
#define fk_app_SensorCapabilities_flags_tag      7
#define fk_app_SensorCapabilities_value_tag      8
#define fk_app_SensorCapabilities_uncalibratedUnitOfMeasure_tag 9
#define fk_app_ModuleHeader_manufacturer_tag     1
#define fk_app_ModuleHeader_kind_tag             2
#define fk_app_ModuleHeader_version_tag          3
#define fk_app_ModuleCapabilities_position_tag   1
#define fk_app_ModuleCapabilities_name_tag       2
#define fk_app_ModuleCapabilities_sensors_tag    3
#define fk_app_ModuleCapabilities_path_tag       4
#define fk_app_ModuleCapabilities_flags_tag      5
#define fk_app_ModuleCapabilities_id_tag         6
#define fk_app_ModuleCapabilities_header_tag     7
#define fk_app_ModuleCapabilities_configuration_tag 8
#define fk_app_Capabilities_version_tag          1
#define fk_app_Capabilities_deviceId_tag         2
#define fk_app_Capabilities_name_tag             3
#define fk_app_Capabilities_modules_tag          4
#define fk_app_Capabilities_sensors_tag          5
#define fk_app_NetworkInfo_ssid_tag              1
#define fk_app_NetworkInfo_password_tag          2
#define fk_app_NetworkInfo_create_tag            3
#define fk_app_NetworkInfo_preferred_tag         4
#define fk_app_NetworkInfo_keeping_tag           5
#define fk_app_NetworkSettings_createAccessPoint_tag 1
#define fk_app_NetworkSettings_networks_tag      2
#define fk_app_NetworkSettings_connected_tag     3
#define fk_app_NetworkSettings_macAddress_tag    4
#define fk_app_NetworkSettings_modifying_tag     5
#define fk_app_NetworkSettings_supportsUdp_tag   6
#define fk_app_Firmware_version_tag              1
#define fk_app_Firmware_build_tag                2
#define fk_app_Firmware_number_tag               3
#define fk_app_Firmware_timestamp_tag            4
#define fk_app_Firmware_hash_tag                 5
#define fk_app_Firmware_logical_address_tag      6
#define fk_app_Firmware_name_tag                 7
#define fk_app_Identity_device_tag               1
#define fk_app_Identity_stream_tag               2
#define fk_app_Identity_deviceId_tag             3
#define fk_app_Identity_firmware_tag             4
#define fk_app_Identity_build_tag                5
#define fk_app_Identity_name_tag                 6
#define fk_app_Identity_generationId_tag         7
#define fk_app_Identity_number_tag               8
#define fk_app_ConfigureSensorQuery_id_tag       1
#define fk_app_ConfigureSensorQuery_frequency_tag 2
#define fk_app_LiveDataPoll_interval_tag         1
#define fk_app_LiveDataSample_sensor_tag         1
#define fk_app_LiveDataSample_time_tag           2
#define fk_app_LiveDataSample_value_tag          3
#define fk_app_LiveData_samples_tag              1
#define fk_app_File_id_tag                       1
#define fk_app_File_time_tag                     2
#define fk_app_File_size_tag                     3
#define fk_app_File_version_tag                  4
#define fk_app_File_name_tag                     5
#define fk_app_File_maximum_tag                  6
#define fk_app_Files_files_tag                   1
#define fk_app_DownloadFile_id_tag               1
#define fk_app_DownloadFile_offset_tag           2
#define fk_app_DownloadFile_length_tag           3
#define fk_app_DownloadFile_flags_tag            4
#define fk_app_EraseFile_id_tag                  1
#define fk_app_FileData_offset_tag               1
#define fk_app_FileData_data_tag                 2
#define fk_app_FileData_size_tag                 3
#define fk_app_FileData_hash_tag                 4
#define fk_app_FileData_version_tag              5
#define fk_app_FileData_id_tag                   6
#define fk_app_DeviceStatus_uptime_tag           1
#define fk_app_DeviceStatus_batteryPercentage_tag 2
#define fk_app_DeviceStatus_batteryVoltage_tag   3
#define fk_app_DeviceStatus_gpsHasFix_tag        4
#define fk_app_DeviceStatus_gpsSatellites_tag    5
#define fk_app_QueryModule_id_tag                1
#define fk_app_QueryModule_address_tag           2
#define fk_app_QueryModule_message_tag           3
#define fk_app_ModuleReply_id_tag                1
#define fk_app_ModuleReply_address_tag           2
#define fk_app_ModuleReply_message_tag           3
#define fk_app_WireMessageQuery_type_tag         1
#define fk_app_WireMessageQuery_queryCapabilities_tag 2
#define fk_app_WireMessageQuery_configureSensor_tag 3
#define fk_app_WireMessageQuery_liveDataPoll_tag 8
#define fk_app_WireMessageQuery_downloadFile_tag 10
#define fk_app_WireMessageQuery_eraseFile_tag    11
#define fk_app_WireMessageQuery_networkSettings_tag 12
#define fk_app_WireMessageQuery_identity_tag     13
#define fk_app_WireMessageQuery_module_tag       14
#define fk_app_Error_message_tag                 1
#define fk_app_Error_delay_tag                   2
#define fk_app_WireMessageReply_type_tag         1
#define fk_app_WireMessageReply_errors_tag       2
#define fk_app_WireMessageReply_capabilities_tag 3
#define fk_app_WireMessageReply_liveData_tag     6
#define fk_app_WireMessageReply_files_tag        8
#define fk_app_WireMessageReply_fileData_tag     9
#define fk_app_WireMessageReply_networkSettings_tag 10
#define fk_app_WireMessageReply_identity_tag     11
#define fk_app_WireMessageReply_status_tag       12
#define fk_app_WireMessageReply_module_tag       13
#define fk_app_Interval_start_tag                1
#define fk_app_Interval_end_tag                  2
#define fk_app_Interval_interval_tag             3
#define fk_app_Schedule_cron_tag                 1
#define fk_app_Schedule_interval_tag             2
#define fk_app_Schedule_repeated_tag             3
#define fk_app_Schedule_duration_tag             4
#define fk_app_Schedule_jitter_tag               5
#define fk_app_Schedule_intervals_tag            6
#define fk_app_Schedules_modifying_tag           1
#define fk_app_Schedules_readings_tag            2
#define fk_app_Schedules_lora_tag                3
#define fk_app_Schedules_network_tag             4
#define fk_app_Schedules_gps_tag                 5
#define fk_app_GpsStatus_fix_tag                 1
#define fk_app_GpsStatus_time_tag                2
#define fk_app_GpsStatus_satellites_tag          3
#define fk_app_GpsStatus_longitude_tag           4
#define fk_app_GpsStatus_latitude_tag            5
#define fk_app_GpsStatus_altitude_tag            6
#define fk_app_GpsStatus_enabled_tag             7
#define fk_app_MemoryStatus_sramAvailable_tag    1
#define fk_app_MemoryStatus_programFlashAvailable_tag 2
#define fk_app_MemoryStatus_extendedMemoryAvailable_tag 3
#define fk_app_MemoryStatus_dataMemoryInstalled_tag 4
#define fk_app_MemoryStatus_dataMemoryUsed_tag   5
#define fk_app_MemoryStatus_dataMemoryConsumption_tag 6
#define fk_app_MemoryStatus_firmware_tag         7
#define fk_app_BatteryStatus_voltage_tag         1
#define fk_app_BatteryStatus_percentage_tag      2
#define fk_app_SolarStatus_voltage_tag           1
#define fk_app_PowerStatus_battery_tag           1
#define fk_app_PowerStatus_solar_tag             2
#define fk_app_Range_start_tag                   1
#define fk_app_Range_end_tag                     2
#define fk_app_DownloadQuery_stream_tag          1
#define fk_app_DownloadQuery_ranges_tag          3
#define fk_app_DownloadQuery_blocks_tag          4
#define fk_app_LoraSettings_available_tag        1
#define fk_app_LoraSettings_modifying_tag        2
#define fk_app_LoraSettings_clearing_tag         3
#define fk_app_LoraSettings_frequencyBand_tag    4
#define fk_app_LoraSettings_deviceEui_tag        5
#define fk_app_LoraSettings_appKey_tag           6
#define fk_app_LoraSettings_joinEui_tag          7
#define fk_app_LoraSettings_deviceAddress_tag    8
#define fk_app_LoraSettings_networkSessionKey_tag 9
#define fk_app_LoraSettings_appSessionKey_tag    10
#define fk_app_LoraSettings_verify_tag           11
#define fk_app_Location_modifying_tag            1
#define fk_app_Location_longitude_tag            2
#define fk_app_Location_latitude_tag             3
#define fk_app_Location_time_tag                 4
#define fk_app_Recording_modifying_tag           1
#define fk_app_Recording_enabled_tag             2
#define fk_app_Recording_startedTime_tag         3
#define fk_app_Recording_location_tag            4
#define fk_app_Status_version_tag                1
#define fk_app_Status_uptime_tag                 2
#define fk_app_Status_identity_tag               3
#define fk_app_Status_hardware_tag               4
#define fk_app_Status_power_tag                  5
#define fk_app_Status_memory_tag                 6
#define fk_app_Status_gps_tag                    7
#define fk_app_Status_schedules_tag              8
#define fk_app_Status_recording_tag              9
#define fk_app_Status_network_tag                10
#define fk_app_Status_time_tag                   11
#define fk_app_Status_firmware_tag               12
#define fk_app_Status_logs_tag                   13
#define fk_app_WifiTransmission_modifying_tag    1
#define fk_app_WifiTransmission_url_tag          2
#define fk_app_WifiTransmission_token_tag        3
#define fk_app_WifiTransmission_enabled_tag      4
#define fk_app_Transmission_wifi_tag             1
#define fk_app_ListDirectory_path_tag            1
#define fk_app_ListDirectory_page_tag            2
#define fk_app_HttpQuery_type_tag                1
#define fk_app_HttpQuery_identity_tag            2
#define fk_app_HttpQuery_recording_tag           3
#define fk_app_HttpQuery_schedules_tag           4
#define fk_app_HttpQuery_flags_tag               5
#define fk_app_HttpQuery_networkSettings_tag     6
#define fk_app_HttpQuery_loraSettings_tag        7
#define fk_app_HttpQuery_time_tag                8
#define fk_app_HttpQuery_locate_tag              9
#define fk_app_HttpQuery_transmission_tag        10
#define fk_app_HttpQuery_directory_tag           11
#define fk_app_HttpQuery_counter_tag             12
#define fk_app_DataStream_id_tag                 1
#define fk_app_DataStream_time_tag               2
#define fk_app_DataStream_size_tag               3
#define fk_app_DataStream_version_tag            4
#define fk_app_DataStream_block_tag              5
#define fk_app_DataStream_hash_tag               6
#define fk_app_DataStream_name_tag               7
#define fk_app_DataStream_path_tag               8
#define fk_app_LiveSensorReading_sensor_tag      1
#define fk_app_LiveSensorReading_value_tag       2
#define fk_app_LiveSensorReading_uncalibrated_tag 3
#define fk_app_LiveSensorReading_factory_tag     4
#define fk_app_LiveSensorReading_adc_tag         5
#define fk_app_LiveModuleReadings_module_tag     1
#define fk_app_LiveModuleReadings_readings_tag   2
#define fk_app_LiveReadings_time_tag             1
#define fk_app_LiveReadings_modules_tag          2
#define fk_app_DirectoryEntry_name_tag           1
#define fk_app_DirectoryEntry_path_tag           2
#define fk_app_DirectoryEntry_size_tag           3
#define fk_app_DirectoryEntry_directory_tag      4
#define fk_app_DirectoryListing_path_tag         1
#define fk_app_DirectoryListing_entries_tag      2
#define fk_app_DirectoryListing_totalEntries_tag 3
#define fk_app_NearbyNetwork_ssid_tag            1
#define fk_app_NearbyNetworks_networks_tag       1
#define fk_app_HttpReply_type_tag                1
#define fk_app_HttpReply_errors_tag              2
#define fk_app_HttpReply_status_tag              3
#define fk_app_HttpReply_networkSettings_tag     4
#define fk_app_HttpReply_modules_tag             5
#define fk_app_HttpReply_streams_tag             6
#define fk_app_HttpReply_liveReadings_tag        7
#define fk_app_HttpReply_loraSettings_tag        8
#define fk_app_HttpReply_schedules_tag           9
#define fk_app_HttpReply_transmission_tag        10
#define fk_app_HttpReply_listing_tag             11
#define fk_app_HttpReply_nearbyNetworks_tag      12
#define fk_app_HttpReply_events_tag              13
#define fk_app_ModuleHttpQuery_type_tag          1
#define fk_app_ModuleHttpQuery_errors_tag        2
#define fk_app_ModuleHttpQuery_configuration_tag 3
#define fk_app_ModuleHttpReply_type_tag          1
#define fk_app_ModuleHttpReply_errors_tag        2
#define fk_app_ModuleHttpReply_configuration_tag 3
#define fk_app_UdpMessage_deviceId_tag           1
#define fk_app_UdpMessage_status_tag             2
#define fk_app_UdpMessage_counter_tag            3
#define fk_app_UdpMessage_port_tag               4

/* Struct field encoding specification for nanopb */
#define fk_app_QueryCapabilities_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   version,           1) \
X(a, STATIC,   SINGULAR, UINT32,   callerTime,        2)
#define fk_app_QueryCapabilities_CALLBACK NULL
#define fk_app_QueryCapabilities_DEFAULT NULL

#define fk_app_LiveValue_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, BOOL,     valid,             1) \
X(a, STATIC,   SINGULAR, FLOAT,    value,             2) \
X(a, STATIC,   SINGULAR, FLOAT,    uncalibrated,      3)
#define fk_app_LiveValue_CALLBACK NULL
#define fk_app_LiveValue_DEFAULT NULL

#define fk_app_SensorCapabilities_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   number,            1) \
X(a, STATIC,   SINGULAR, UINT32,   module,            2) \
X(a, CALLBACK, SINGULAR, STRING,   name,              3) \
X(a, STATIC,   SINGULAR, UINT32,   frequency,         4) \
X(a, CALLBACK, SINGULAR, STRING,   unitOfMeasure,     5) \
X(a, CALLBACK, SINGULAR, STRING,   path,              6) \
X(a, STATIC,   SINGULAR, UINT32,   flags,             7) \
X(a, STATIC,   OPTIONAL, MESSAGE,  value,             8) \
X(a, CALLBACK, SINGULAR, STRING,   uncalibratedUnitOfMeasure,   9)
#define fk_app_SensorCapabilities_CALLBACK pb_default_field_callback
#define fk_app_SensorCapabilities_DEFAULT NULL
#define fk_app_SensorCapabilities_value_MSGTYPE fk_app_LiveValue

#define fk_app_ModuleHeader_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   manufacturer,      1) \
X(a, STATIC,   SINGULAR, UINT32,   kind,              2) \
X(a, STATIC,   SINGULAR, UINT32,   version,           3)
#define fk_app_ModuleHeader_CALLBACK NULL
#define fk_app_ModuleHeader_DEFAULT NULL

#define fk_app_ModuleCapabilities_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   position,          1) \
X(a, CALLBACK, SINGULAR, STRING,   name,              2) \
X(a, CALLBACK, REPEATED, MESSAGE,  sensors,           3) \
X(a, CALLBACK, SINGULAR, STRING,   path,              4) \
X(a, STATIC,   SINGULAR, UINT32,   flags,             5) \
X(a, CALLBACK, SINGULAR, BYTES,    id,                6) \
X(a, STATIC,   OPTIONAL, MESSAGE,  header,            7) \
X(a, CALLBACK, SINGULAR, BYTES,    configuration,     8)
#define fk_app_ModuleCapabilities_CALLBACK pb_default_field_callback
#define fk_app_ModuleCapabilities_DEFAULT NULL
#define fk_app_ModuleCapabilities_sensors_MSGTYPE fk_app_SensorCapabilities
#define fk_app_ModuleCapabilities_header_MSGTYPE fk_app_ModuleHeader

#define fk_app_Capabilities_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   version,           1) \
X(a, CALLBACK, SINGULAR, BYTES,    deviceId,          2) \
X(a, CALLBACK, SINGULAR, STRING,   name,              3) \
X(a, CALLBACK, REPEATED, MESSAGE,  modules,           4) \
X(a, CALLBACK, REPEATED, MESSAGE,  sensors,           5)
#define fk_app_Capabilities_CALLBACK pb_default_field_callback
#define fk_app_Capabilities_DEFAULT NULL
#define fk_app_Capabilities_modules_MSGTYPE fk_app_ModuleCapabilities
#define fk_app_Capabilities_sensors_MSGTYPE fk_app_SensorCapabilities

#define fk_app_NetworkInfo_FIELDLIST(X, a) \
X(a, CALLBACK, SINGULAR, STRING,   ssid,              1) \
X(a, CALLBACK, SINGULAR, STRING,   password,          2) \
X(a, STATIC,   SINGULAR, BOOL,     create,            3) \
X(a, STATIC,   SINGULAR, BOOL,     preferred,         4) \
X(a, STATIC,   SINGULAR, BOOL,     keeping,           5)
#define fk_app_NetworkInfo_CALLBACK pb_default_field_callback
#define fk_app_NetworkInfo_DEFAULT NULL

#define fk_app_NetworkSettings_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, INT32,    createAccessPoint,   1) \
X(a, CALLBACK, REPEATED, MESSAGE,  networks,          2) \
X(a, STATIC,   OPTIONAL, MESSAGE,  connected,         3) \
X(a, CALLBACK, SINGULAR, STRING,   macAddress,        4) \
X(a, STATIC,   SINGULAR, BOOL,     modifying,         5) \
X(a, STATIC,   SINGULAR, BOOL,     supportsUdp,       6)
#define fk_app_NetworkSettings_CALLBACK pb_default_field_callback
#define fk_app_NetworkSettings_DEFAULT NULL
#define fk_app_NetworkSettings_networks_MSGTYPE fk_app_NetworkInfo
#define fk_app_NetworkSettings_connected_MSGTYPE fk_app_NetworkInfo

#define fk_app_Firmware_FIELDLIST(X, a) \
X(a, CALLBACK, SINGULAR, STRING,   version,           1) \
X(a, CALLBACK, SINGULAR, STRING,   build,             2) \
X(a, CALLBACK, SINGULAR, STRING,   number,            3) \
X(a, STATIC,   SINGULAR, UINT64,   timestamp,         4) \
X(a, CALLBACK, SINGULAR, STRING,   hash,              5) \
X(a, STATIC,   SINGULAR, UINT64,   logical_address,   6) \
X(a, CALLBACK, SINGULAR, STRING,   name,              7)
#define fk_app_Firmware_CALLBACK pb_default_field_callback
#define fk_app_Firmware_DEFAULT NULL

#define fk_app_Identity_FIELDLIST(X, a) \
X(a, CALLBACK, SINGULAR, STRING,   device,            1) \
X(a, CALLBACK, SINGULAR, STRING,   stream,            2) \
X(a, CALLBACK, SINGULAR, BYTES,    deviceId,          3) \
X(a, CALLBACK, SINGULAR, STRING,   firmware,          4) \
X(a, CALLBACK, SINGULAR, STRING,   build,             5) \
X(a, CALLBACK, SINGULAR, STRING,   name,              6) \
X(a, CALLBACK, SINGULAR, BYTES,    generationId,      7) \
X(a, CALLBACK, SINGULAR, STRING,   number,            8)
#define fk_app_Identity_CALLBACK pb_default_field_callback
#define fk_app_Identity_DEFAULT NULL

#define fk_app_ConfigureSensorQuery_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   id,                1) \
X(a, STATIC,   SINGULAR, UINT32,   frequency,         2)
#define fk_app_ConfigureSensorQuery_CALLBACK NULL
#define fk_app_ConfigureSensorQuery_DEFAULT NULL

#define fk_app_LiveDataPoll_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   interval,          1)
#define fk_app_LiveDataPoll_CALLBACK NULL
#define fk_app_LiveDataPoll_DEFAULT NULL

#define fk_app_LiveDataSample_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   sensor,            1) \
X(a, STATIC,   SINGULAR, UINT64,   time,              2) \
X(a, STATIC,   SINGULAR, FLOAT,    value,             3)
#define fk_app_LiveDataSample_CALLBACK NULL
#define fk_app_LiveDataSample_DEFAULT NULL

#define fk_app_LiveData_FIELDLIST(X, a) \
X(a, CALLBACK, REPEATED, MESSAGE,  samples,           1)
#define fk_app_LiveData_CALLBACK pb_default_field_callback
#define fk_app_LiveData_DEFAULT NULL
#define fk_app_LiveData_samples_MSGTYPE fk_app_LiveDataSample

#define fk_app_File_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   id,                1) \
X(a, STATIC,   SINGULAR, UINT64,   time,              2) \
X(a, STATIC,   SINGULAR, UINT64,   size,              3) \
X(a, STATIC,   SINGULAR, UINT32,   version,           4) \
X(a, CALLBACK, SINGULAR, STRING,   name,              5) \
X(a, STATIC,   SINGULAR, UINT64,   maximum,           6)
#define fk_app_File_CALLBACK pb_default_field_callback
#define fk_app_File_DEFAULT NULL

#define fk_app_Files_FIELDLIST(X, a) \
X(a, CALLBACK, REPEATED, MESSAGE,  files,             1)
#define fk_app_Files_CALLBACK pb_default_field_callback
#define fk_app_Files_DEFAULT NULL
#define fk_app_Files_files_MSGTYPE fk_app_File

#define fk_app_DownloadFile_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   id,                1) \
X(a, STATIC,   SINGULAR, UINT32,   offset,            2) \
X(a, STATIC,   SINGULAR, UINT32,   length,            3) \
X(a, STATIC,   SINGULAR, UINT32,   flags,             4)
#define fk_app_DownloadFile_CALLBACK NULL
#define fk_app_DownloadFile_DEFAULT NULL

#define fk_app_EraseFile_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   id,                1)
#define fk_app_EraseFile_CALLBACK NULL
#define fk_app_EraseFile_DEFAULT NULL

#define fk_app_FileData_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   offset,            1) \
X(a, CALLBACK, SINGULAR, BYTES,    data,              2) \
X(a, STATIC,   SINGULAR, UINT32,   size,              3) \
X(a, STATIC,   SINGULAR, UINT32,   hash,              4) \
X(a, STATIC,   SINGULAR, UINT32,   version,           5) \
X(a, STATIC,   SINGULAR, UINT32,   id,                6)
#define fk_app_FileData_CALLBACK pb_default_field_callback
#define fk_app_FileData_DEFAULT NULL

#define fk_app_DeviceStatus_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   uptime,            1) \
X(a, STATIC,   SINGULAR, FLOAT,    batteryPercentage,   2) \
X(a, STATIC,   SINGULAR, FLOAT,    batteryVoltage,    3) \
X(a, STATIC,   SINGULAR, UINT32,   gpsHasFix,         4) \
X(a, STATIC,   SINGULAR, UINT32,   gpsSatellites,     5)
#define fk_app_DeviceStatus_CALLBACK NULL
#define fk_app_DeviceStatus_DEFAULT NULL

#define fk_app_QueryModule_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   id,                1) \
X(a, STATIC,   SINGULAR, UINT32,   address,           2) \
X(a, CALLBACK, SINGULAR, BYTES,    message,           3)
#define fk_app_QueryModule_CALLBACK pb_default_field_callback
#define fk_app_QueryModule_DEFAULT NULL

#define fk_app_ModuleReply_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   id,                1) \
X(a, STATIC,   SINGULAR, UINT32,   address,           2) \
X(a, CALLBACK, SINGULAR, BYTES,    message,           3)
#define fk_app_ModuleReply_CALLBACK pb_default_field_callback
#define fk_app_ModuleReply_DEFAULT NULL

#define fk_app_WireMessageQuery_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    type,              1) \
X(a, STATIC,   OPTIONAL, MESSAGE,  queryCapabilities,   2) \
X(a, STATIC,   OPTIONAL, MESSAGE,  configureSensor,   3) \
X(a, STATIC,   OPTIONAL, MESSAGE,  liveDataPoll,      8) \
X(a, STATIC,   OPTIONAL, MESSAGE,  downloadFile,     10) \
X(a, STATIC,   OPTIONAL, MESSAGE,  eraseFile,        11) \
X(a, STATIC,   OPTIONAL, MESSAGE,  networkSettings,  12) \
X(a, STATIC,   OPTIONAL, MESSAGE,  identity,         13) \
X(a, STATIC,   OPTIONAL, MESSAGE,  module,           14)
#define fk_app_WireMessageQuery_CALLBACK NULL
#define fk_app_WireMessageQuery_DEFAULT NULL
#define fk_app_WireMessageQuery_queryCapabilities_MSGTYPE fk_app_QueryCapabilities
#define fk_app_WireMessageQuery_configureSensor_MSGTYPE fk_app_ConfigureSensorQuery
#define fk_app_WireMessageQuery_liveDataPoll_MSGTYPE fk_app_LiveDataPoll
#define fk_app_WireMessageQuery_downloadFile_MSGTYPE fk_app_DownloadFile
#define fk_app_WireMessageQuery_eraseFile_MSGTYPE fk_app_EraseFile
#define fk_app_WireMessageQuery_networkSettings_MSGTYPE fk_app_NetworkSettings
#define fk_app_WireMessageQuery_identity_MSGTYPE fk_app_Identity
#define fk_app_WireMessageQuery_module_MSGTYPE fk_app_QueryModule

#define fk_app_Error_FIELDLIST(X, a) \
X(a, CALLBACK, SINGULAR, STRING,   message,           1) \
X(a, STATIC,   SINGULAR, UINT32,   delay,             2)
#define fk_app_Error_CALLBACK pb_default_field_callback
#define fk_app_Error_DEFAULT NULL

#define fk_app_WireMessageReply_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    type,              1) \
X(a, CALLBACK, REPEATED, MESSAGE,  errors,            2) \
X(a, STATIC,   OPTIONAL, MESSAGE,  capabilities,      3) \
X(a, STATIC,   OPTIONAL, MESSAGE,  liveData,          6) \
X(a, STATIC,   OPTIONAL, MESSAGE,  files,             8) \
X(a, STATIC,   OPTIONAL, MESSAGE,  fileData,          9) \
X(a, STATIC,   OPTIONAL, MESSAGE,  networkSettings,  10) \
X(a, STATIC,   OPTIONAL, MESSAGE,  identity,         11) \
X(a, STATIC,   OPTIONAL, MESSAGE,  status,           12) \
X(a, STATIC,   OPTIONAL, MESSAGE,  module,           13)
#define fk_app_WireMessageReply_CALLBACK pb_default_field_callback
#define fk_app_WireMessageReply_DEFAULT NULL
#define fk_app_WireMessageReply_errors_MSGTYPE fk_app_Error
#define fk_app_WireMessageReply_capabilities_MSGTYPE fk_app_Capabilities
#define fk_app_WireMessageReply_liveData_MSGTYPE fk_app_LiveData
#define fk_app_WireMessageReply_files_MSGTYPE fk_app_Files
#define fk_app_WireMessageReply_fileData_MSGTYPE fk_app_FileData
#define fk_app_WireMessageReply_networkSettings_MSGTYPE fk_app_NetworkSettings
#define fk_app_WireMessageReply_identity_MSGTYPE fk_app_Identity
#define fk_app_WireMessageReply_status_MSGTYPE fk_app_DeviceStatus
#define fk_app_WireMessageReply_module_MSGTYPE fk_app_ModuleReply

#define fk_app_Interval_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT64,   start,             1) \
X(a, STATIC,   SINGULAR, UINT64,   end,               2) \
X(a, STATIC,   SINGULAR, UINT32,   interval,          3)
#define fk_app_Interval_CALLBACK NULL
#define fk_app_Interval_DEFAULT NULL

#define fk_app_Schedule_FIELDLIST(X, a) \
X(a, CALLBACK, SINGULAR, BYTES,    cron,              1) \
X(a, STATIC,   SINGULAR, UINT32,   interval,          2) \
X(a, STATIC,   SINGULAR, UINT32,   repeated,          3) \
X(a, STATIC,   SINGULAR, UINT32,   duration,          4) \
X(a, STATIC,   SINGULAR, UINT32,   jitter,            5) \
X(a, CALLBACK, REPEATED, MESSAGE,  intervals,         6)
#define fk_app_Schedule_CALLBACK pb_default_field_callback
#define fk_app_Schedule_DEFAULT NULL
#define fk_app_Schedule_intervals_MSGTYPE fk_app_Interval

#define fk_app_Schedules_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, BOOL,     modifying,         1) \
X(a, STATIC,   OPTIONAL, MESSAGE,  readings,          2) \
X(a, STATIC,   OPTIONAL, MESSAGE,  lora,              3) \
X(a, STATIC,   OPTIONAL, MESSAGE,  network,           4) \
X(a, STATIC,   OPTIONAL, MESSAGE,  gps,               5)
#define fk_app_Schedules_CALLBACK NULL
#define fk_app_Schedules_DEFAULT NULL
#define fk_app_Schedules_readings_MSGTYPE fk_app_Schedule
#define fk_app_Schedules_lora_MSGTYPE fk_app_Schedule
#define fk_app_Schedules_network_MSGTYPE fk_app_Schedule
#define fk_app_Schedules_gps_MSGTYPE fk_app_Schedule

#define fk_app_HardwareStatus_FIELDLIST(X, a) \

#define fk_app_HardwareStatus_CALLBACK NULL
#define fk_app_HardwareStatus_DEFAULT NULL

#define fk_app_GpsStatus_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   fix,               1) \
X(a, STATIC,   SINGULAR, UINT64,   time,              2) \
X(a, STATIC,   SINGULAR, UINT32,   satellites,        3) \
X(a, STATIC,   SINGULAR, FLOAT,    longitude,         4) \
X(a, STATIC,   SINGULAR, FLOAT,    latitude,          5) \
X(a, STATIC,   SINGULAR, FLOAT,    altitude,          6) \
X(a, STATIC,   SINGULAR, UINT32,   enabled,           7)
#define fk_app_GpsStatus_CALLBACK NULL
#define fk_app_GpsStatus_DEFAULT NULL

#define fk_app_MemoryStatus_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   sramAvailable,     1) \
X(a, STATIC,   SINGULAR, UINT32,   programFlashAvailable,   2) \
X(a, STATIC,   SINGULAR, UINT32,   extendedMemoryAvailable,   3) \
X(a, STATIC,   SINGULAR, UINT32,   dataMemoryInstalled,   4) \
X(a, STATIC,   SINGULAR, UINT32,   dataMemoryUsed,    5) \
X(a, STATIC,   SINGULAR, FLOAT,    dataMemoryConsumption,   6) \
X(a, CALLBACK, REPEATED, MESSAGE,  firmware,          7)
#define fk_app_MemoryStatus_CALLBACK pb_default_field_callback
#define fk_app_MemoryStatus_DEFAULT NULL
#define fk_app_MemoryStatus_firmware_MSGTYPE fk_app_Firmware

#define fk_app_BatteryStatus_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   voltage,           1) \
X(a, STATIC,   SINGULAR, UINT32,   percentage,        2)
#define fk_app_BatteryStatus_CALLBACK NULL
#define fk_app_BatteryStatus_DEFAULT NULL

#define fk_app_SolarStatus_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   voltage,           1)
#define fk_app_SolarStatus_CALLBACK NULL
#define fk_app_SolarStatus_DEFAULT NULL

#define fk_app_PowerStatus_FIELDLIST(X, a) \
X(a, STATIC,   OPTIONAL, MESSAGE,  battery,           1) \
X(a, STATIC,   OPTIONAL, MESSAGE,  solar,             2)
#define fk_app_PowerStatus_CALLBACK NULL
#define fk_app_PowerStatus_DEFAULT NULL
#define fk_app_PowerStatus_battery_MSGTYPE fk_app_BatteryStatus
#define fk_app_PowerStatus_solar_MSGTYPE fk_app_SolarStatus

#define fk_app_Status_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   version,           1) \
X(a, STATIC,   SINGULAR, UINT32,   uptime,            2) \
X(a, STATIC,   OPTIONAL, MESSAGE,  identity,          3) \
X(a, STATIC,   OPTIONAL, MESSAGE,  hardware,          4) \
X(a, STATIC,   OPTIONAL, MESSAGE,  power,             5) \
X(a, STATIC,   OPTIONAL, MESSAGE,  memory,            6) \
X(a, STATIC,   OPTIONAL, MESSAGE,  gps,               7) \
X(a, STATIC,   OPTIONAL, MESSAGE,  schedules,         8) \
X(a, STATIC,   OPTIONAL, MESSAGE,  recording,         9) \
X(a, STATIC,   OPTIONAL, MESSAGE,  network,          10) \
X(a, STATIC,   SINGULAR, UINT64,   time,             11) \
X(a, STATIC,   OPTIONAL, MESSAGE,  firmware,         12) \
X(a, CALLBACK, SINGULAR, STRING,   logs,             13)
#define fk_app_Status_CALLBACK pb_default_field_callback
#define fk_app_Status_DEFAULT NULL
#define fk_app_Status_identity_MSGTYPE fk_app_Identity
#define fk_app_Status_hardware_MSGTYPE fk_app_HardwareStatus
#define fk_app_Status_power_MSGTYPE fk_app_PowerStatus
#define fk_app_Status_memory_MSGTYPE fk_app_MemoryStatus
#define fk_app_Status_gps_MSGTYPE fk_app_GpsStatus
#define fk_app_Status_schedules_MSGTYPE fk_app_Schedules
#define fk_app_Status_recording_MSGTYPE fk_app_Recording
#define fk_app_Status_network_MSGTYPE fk_app_NetworkSettings
#define fk_app_Status_firmware_MSGTYPE fk_app_Firmware

#define fk_app_Range_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   start,             1) \
X(a, STATIC,   SINGULAR, UINT32,   end,               2)
#define fk_app_Range_CALLBACK NULL
#define fk_app_Range_DEFAULT NULL

#define fk_app_DownloadQuery_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   stream,            1) \
X(a, CALLBACK, REPEATED, MESSAGE,  ranges,            3) \
X(a, CALLBACK, REPEATED, UINT32,   blocks,            4)
#define fk_app_DownloadQuery_CALLBACK pb_default_field_callback
#define fk_app_DownloadQuery_DEFAULT NULL
#define fk_app_DownloadQuery_ranges_MSGTYPE fk_app_Range

#define fk_app_Recording_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, BOOL,     modifying,         1) \
X(a, STATIC,   SINGULAR, BOOL,     enabled,           2) \
X(a, STATIC,   SINGULAR, UINT64,   startedTime,       3) \
X(a, STATIC,   OPTIONAL, MESSAGE,  location,          4)
#define fk_app_Recording_CALLBACK NULL
#define fk_app_Recording_DEFAULT NULL
#define fk_app_Recording_location_MSGTYPE fk_app_Location

#define fk_app_LoraSettings_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, BOOL,     available,         1) \
X(a, STATIC,   SINGULAR, BOOL,     modifying,         2) \
X(a, STATIC,   SINGULAR, BOOL,     clearing,          3) \
X(a, STATIC,   SINGULAR, UINT32,   frequencyBand,     4) \
X(a, CALLBACK, SINGULAR, BYTES,    deviceEui,         5) \
X(a, CALLBACK, SINGULAR, BYTES,    appKey,            6) \
X(a, CALLBACK, SINGULAR, BYTES,    joinEui,           7) \
X(a, CALLBACK, SINGULAR, BYTES,    deviceAddress,     8) \
X(a, CALLBACK, SINGULAR, BYTES,    networkSessionKey,   9) \
X(a, CALLBACK, SINGULAR, BYTES,    appSessionKey,    10) \
X(a, STATIC,   SINGULAR, BOOL,     verify,           11)
#define fk_app_LoraSettings_CALLBACK pb_default_field_callback
#define fk_app_LoraSettings_DEFAULT NULL

#define fk_app_Location_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, BOOL,     modifying,         1) \
X(a, STATIC,   SINGULAR, FLOAT,    longitude,         2) \
X(a, STATIC,   SINGULAR, FLOAT,    latitude,          3) \
X(a, STATIC,   SINGULAR, UINT64,   time,              4)
#define fk_app_Location_CALLBACK NULL
#define fk_app_Location_DEFAULT NULL

#define fk_app_WifiTransmission_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, BOOL,     modifying,         1) \
X(a, CALLBACK, SINGULAR, STRING,   url,               2) \
X(a, CALLBACK, SINGULAR, STRING,   token,             3) \
X(a, STATIC,   SINGULAR, BOOL,     enabled,           4)
#define fk_app_WifiTransmission_CALLBACK pb_default_field_callback
#define fk_app_WifiTransmission_DEFAULT NULL

#define fk_app_Transmission_FIELDLIST(X, a) \
X(a, STATIC,   OPTIONAL, MESSAGE,  wifi,              1)
#define fk_app_Transmission_CALLBACK NULL
#define fk_app_Transmission_DEFAULT NULL
#define fk_app_Transmission_wifi_MSGTYPE fk_app_WifiTransmission

#define fk_app_ListDirectory_FIELDLIST(X, a) \
X(a, CALLBACK, SINGULAR, STRING,   path,              1) \
X(a, STATIC,   SINGULAR, UINT32,   page,              2)
#define fk_app_ListDirectory_CALLBACK pb_default_field_callback
#define fk_app_ListDirectory_DEFAULT NULL

#define fk_app_HttpQuery_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    type,              1) \
X(a, STATIC,   OPTIONAL, MESSAGE,  identity,          2) \
X(a, STATIC,   OPTIONAL, MESSAGE,  recording,         3) \
X(a, STATIC,   OPTIONAL, MESSAGE,  schedules,         4) \
X(a, STATIC,   SINGULAR, UINT32,   flags,             5) \
X(a, STATIC,   OPTIONAL, MESSAGE,  networkSettings,   6) \
X(a, STATIC,   OPTIONAL, MESSAGE,  loraSettings,      7) \
X(a, STATIC,   SINGULAR, UINT64,   time,              8) \
X(a, STATIC,   OPTIONAL, MESSAGE,  locate,            9) \
X(a, STATIC,   OPTIONAL, MESSAGE,  transmission,     10) \
X(a, STATIC,   OPTIONAL, MESSAGE,  directory,        11) \
X(a, STATIC,   SINGULAR, UINT32,   counter,          12)
#define fk_app_HttpQuery_CALLBACK NULL
#define fk_app_HttpQuery_DEFAULT NULL
#define fk_app_HttpQuery_identity_MSGTYPE fk_app_Identity
#define fk_app_HttpQuery_recording_MSGTYPE fk_app_Recording
#define fk_app_HttpQuery_schedules_MSGTYPE fk_app_Schedules
#define fk_app_HttpQuery_networkSettings_MSGTYPE fk_app_NetworkSettings
#define fk_app_HttpQuery_loraSettings_MSGTYPE fk_app_LoraSettings
#define fk_app_HttpQuery_locate_MSGTYPE fk_app_Location
#define fk_app_HttpQuery_transmission_MSGTYPE fk_app_Transmission
#define fk_app_HttpQuery_directory_MSGTYPE fk_app_ListDirectory

#define fk_app_DataStream_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   id,                1) \
X(a, STATIC,   SINGULAR, UINT64,   time,              2) \
X(a, STATIC,   SINGULAR, UINT64,   size,              3) \
X(a, STATIC,   SINGULAR, UINT32,   version,           4) \
X(a, STATIC,   SINGULAR, UINT64,   block,             5) \
X(a, CALLBACK, SINGULAR, BYTES,    hash,              6) \
X(a, CALLBACK, SINGULAR, STRING,   name,              7) \
X(a, CALLBACK, SINGULAR, STRING,   path,              8)
#define fk_app_DataStream_CALLBACK pb_default_field_callback
#define fk_app_DataStream_DEFAULT NULL

#define fk_app_LiveSensorReading_FIELDLIST(X, a) \
X(a, STATIC,   OPTIONAL, MESSAGE,  sensor,            1) \
X(a, STATIC,   SINGULAR, FLOAT,    value,             2) \
X(a, STATIC,   SINGULAR, FLOAT,    uncalibrated,      3) \
X(a, STATIC,   SINGULAR, FLOAT,    factory,           4) \
X(a, CALLBACK, SINGULAR, BYTES,    adc,               5)
#define fk_app_LiveSensorReading_CALLBACK pb_default_field_callback
#define fk_app_LiveSensorReading_DEFAULT NULL
#define fk_app_LiveSensorReading_sensor_MSGTYPE fk_app_SensorCapabilities

#define fk_app_LiveModuleReadings_FIELDLIST(X, a) \
X(a, STATIC,   OPTIONAL, MESSAGE,  module,            1) \
X(a, CALLBACK, REPEATED, MESSAGE,  readings,          2)
#define fk_app_LiveModuleReadings_CALLBACK pb_default_field_callback
#define fk_app_LiveModuleReadings_DEFAULT NULL
#define fk_app_LiveModuleReadings_module_MSGTYPE fk_app_ModuleCapabilities
#define fk_app_LiveModuleReadings_readings_MSGTYPE fk_app_LiveSensorReading

#define fk_app_LiveReadings_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT64,   time,              1) \
X(a, CALLBACK, REPEATED, MESSAGE,  modules,           2)
#define fk_app_LiveReadings_CALLBACK pb_default_field_callback
#define fk_app_LiveReadings_DEFAULT NULL
#define fk_app_LiveReadings_modules_MSGTYPE fk_app_LiveModuleReadings

#define fk_app_DirectoryEntry_FIELDLIST(X, a) \
X(a, CALLBACK, SINGULAR, STRING,   name,              1) \
X(a, CALLBACK, SINGULAR, STRING,   path,              2) \
X(a, STATIC,   SINGULAR, UINT32,   size,              3) \
X(a, STATIC,   SINGULAR, BOOL,     directory,         4)
#define fk_app_DirectoryEntry_CALLBACK pb_default_field_callback
#define fk_app_DirectoryEntry_DEFAULT NULL

#define fk_app_DirectoryListing_FIELDLIST(X, a) \
X(a, CALLBACK, SINGULAR, STRING,   path,              1) \
X(a, CALLBACK, REPEATED, MESSAGE,  entries,           2) \
X(a, STATIC,   SINGULAR, UINT32,   totalEntries,      3)
#define fk_app_DirectoryListing_CALLBACK pb_default_field_callback
#define fk_app_DirectoryListing_DEFAULT NULL
#define fk_app_DirectoryListing_entries_MSGTYPE fk_app_DirectoryEntry

#define fk_app_NearbyNetwork_FIELDLIST(X, a) \
X(a, CALLBACK, SINGULAR, STRING,   ssid,              1)
#define fk_app_NearbyNetwork_CALLBACK pb_default_field_callback
#define fk_app_NearbyNetwork_DEFAULT NULL

#define fk_app_NearbyNetworks_FIELDLIST(X, a) \
X(a, CALLBACK, REPEATED, MESSAGE,  networks,          1)
#define fk_app_NearbyNetworks_CALLBACK pb_default_field_callback
#define fk_app_NearbyNetworks_DEFAULT NULL
#define fk_app_NearbyNetworks_networks_MSGTYPE fk_app_NearbyNetwork

#define fk_app_HttpReply_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    type,              1) \
X(a, CALLBACK, REPEATED, MESSAGE,  errors,            2) \
X(a, STATIC,   OPTIONAL, MESSAGE,  status,            3) \
X(a, STATIC,   OPTIONAL, MESSAGE,  networkSettings,   4) \
X(a, CALLBACK, REPEATED, MESSAGE,  modules,           5) \
X(a, CALLBACK, REPEATED, MESSAGE,  streams,           6) \
X(a, CALLBACK, REPEATED, MESSAGE,  liveReadings,      7) \
X(a, STATIC,   OPTIONAL, MESSAGE,  loraSettings,      8) \
X(a, STATIC,   OPTIONAL, MESSAGE,  schedules,         9) \
X(a, STATIC,   OPTIONAL, MESSAGE,  transmission,     10) \
X(a, STATIC,   OPTIONAL, MESSAGE,  listing,          11) \
X(a, STATIC,   OPTIONAL, MESSAGE,  nearbyNetworks,   12) \
X(a, CALLBACK, SINGULAR, BYTES,    events,           13)
#define fk_app_HttpReply_CALLBACK pb_default_field_callback
#define fk_app_HttpReply_DEFAULT NULL
#define fk_app_HttpReply_errors_MSGTYPE fk_app_Error
#define fk_app_HttpReply_status_MSGTYPE fk_app_Status
#define fk_app_HttpReply_networkSettings_MSGTYPE fk_app_NetworkSettings
#define fk_app_HttpReply_modules_MSGTYPE fk_app_ModuleCapabilities
#define fk_app_HttpReply_streams_MSGTYPE fk_app_DataStream
#define fk_app_HttpReply_liveReadings_MSGTYPE fk_app_LiveReadings
#define fk_app_HttpReply_loraSettings_MSGTYPE fk_app_LoraSettings
#define fk_app_HttpReply_schedules_MSGTYPE fk_app_Schedules
#define fk_app_HttpReply_transmission_MSGTYPE fk_app_Transmission
#define fk_app_HttpReply_listing_MSGTYPE fk_app_DirectoryListing
#define fk_app_HttpReply_nearbyNetworks_MSGTYPE fk_app_NearbyNetworks

#define fk_app_ModuleHttpQuery_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    type,              1) \
X(a, CALLBACK, REPEATED, MESSAGE,  errors,            2) \
X(a, CALLBACK, SINGULAR, BYTES,    configuration,     3)
#define fk_app_ModuleHttpQuery_CALLBACK pb_default_field_callback
#define fk_app_ModuleHttpQuery_DEFAULT NULL
#define fk_app_ModuleHttpQuery_errors_MSGTYPE fk_app_Error

#define fk_app_ModuleHttpReply_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    type,              1) \
X(a, CALLBACK, REPEATED, MESSAGE,  errors,            2) \
X(a, CALLBACK, SINGULAR, BYTES,    configuration,     3)
#define fk_app_ModuleHttpReply_CALLBACK pb_default_field_callback
#define fk_app_ModuleHttpReply_DEFAULT NULL
#define fk_app_ModuleHttpReply_errors_MSGTYPE fk_app_Error

#define fk_app_UdpMessage_FIELDLIST(X, a) \
X(a, CALLBACK, SINGULAR, BYTES,    deviceId,          1) \
X(a, STATIC,   SINGULAR, UENUM,    status,            2) \
X(a, STATIC,   SINGULAR, UINT32,   counter,           3) \
X(a, STATIC,   SINGULAR, UINT32,   port,              4)
#define fk_app_UdpMessage_CALLBACK pb_default_field_callback
#define fk_app_UdpMessage_DEFAULT NULL

extern const pb_msgdesc_t fk_app_QueryCapabilities_msg;
extern const pb_msgdesc_t fk_app_LiveValue_msg;
extern const pb_msgdesc_t fk_app_SensorCapabilities_msg;
extern const pb_msgdesc_t fk_app_ModuleHeader_msg;
extern const pb_msgdesc_t fk_app_ModuleCapabilities_msg;
extern const pb_msgdesc_t fk_app_Capabilities_msg;
extern const pb_msgdesc_t fk_app_NetworkInfo_msg;
extern const pb_msgdesc_t fk_app_NetworkSettings_msg;
extern const pb_msgdesc_t fk_app_Firmware_msg;
extern const pb_msgdesc_t fk_app_Identity_msg;
extern const pb_msgdesc_t fk_app_ConfigureSensorQuery_msg;
extern const pb_msgdesc_t fk_app_LiveDataPoll_msg;
extern const pb_msgdesc_t fk_app_LiveDataSample_msg;
extern const pb_msgdesc_t fk_app_LiveData_msg;
extern const pb_msgdesc_t fk_app_File_msg;
extern const pb_msgdesc_t fk_app_Files_msg;
extern const pb_msgdesc_t fk_app_DownloadFile_msg;
extern const pb_msgdesc_t fk_app_EraseFile_msg;
extern const pb_msgdesc_t fk_app_FileData_msg;
extern const pb_msgdesc_t fk_app_DeviceStatus_msg;
extern const pb_msgdesc_t fk_app_QueryModule_msg;
extern const pb_msgdesc_t fk_app_ModuleReply_msg;
extern const pb_msgdesc_t fk_app_WireMessageQuery_msg;
extern const pb_msgdesc_t fk_app_Error_msg;
extern const pb_msgdesc_t fk_app_WireMessageReply_msg;
extern const pb_msgdesc_t fk_app_Interval_msg;
extern const pb_msgdesc_t fk_app_Schedule_msg;
extern const pb_msgdesc_t fk_app_Schedules_msg;
extern const pb_msgdesc_t fk_app_HardwareStatus_msg;
extern const pb_msgdesc_t fk_app_GpsStatus_msg;
extern const pb_msgdesc_t fk_app_MemoryStatus_msg;
extern const pb_msgdesc_t fk_app_BatteryStatus_msg;
extern const pb_msgdesc_t fk_app_SolarStatus_msg;
extern const pb_msgdesc_t fk_app_PowerStatus_msg;
extern const pb_msgdesc_t fk_app_Status_msg;
extern const pb_msgdesc_t fk_app_Range_msg;
extern const pb_msgdesc_t fk_app_DownloadQuery_msg;
extern const pb_msgdesc_t fk_app_Recording_msg;
extern const pb_msgdesc_t fk_app_LoraSettings_msg;
extern const pb_msgdesc_t fk_app_Location_msg;
extern const pb_msgdesc_t fk_app_WifiTransmission_msg;
extern const pb_msgdesc_t fk_app_Transmission_msg;
extern const pb_msgdesc_t fk_app_ListDirectory_msg;
extern const pb_msgdesc_t fk_app_HttpQuery_msg;
extern const pb_msgdesc_t fk_app_DataStream_msg;
extern const pb_msgdesc_t fk_app_LiveSensorReading_msg;
extern const pb_msgdesc_t fk_app_LiveModuleReadings_msg;
extern const pb_msgdesc_t fk_app_LiveReadings_msg;
extern const pb_msgdesc_t fk_app_DirectoryEntry_msg;
extern const pb_msgdesc_t fk_app_DirectoryListing_msg;
extern const pb_msgdesc_t fk_app_NearbyNetwork_msg;
extern const pb_msgdesc_t fk_app_NearbyNetworks_msg;
extern const pb_msgdesc_t fk_app_HttpReply_msg;
extern const pb_msgdesc_t fk_app_ModuleHttpQuery_msg;
extern const pb_msgdesc_t fk_app_ModuleHttpReply_msg;
extern const pb_msgdesc_t fk_app_UdpMessage_msg;

/* Defines for backwards compatibility with code written before nanopb-0.4.0 */
#define fk_app_QueryCapabilities_fields &fk_app_QueryCapabilities_msg
#define fk_app_LiveValue_fields &fk_app_LiveValue_msg
#define fk_app_SensorCapabilities_fields &fk_app_SensorCapabilities_msg
#define fk_app_ModuleHeader_fields &fk_app_ModuleHeader_msg
#define fk_app_ModuleCapabilities_fields &fk_app_ModuleCapabilities_msg
#define fk_app_Capabilities_fields &fk_app_Capabilities_msg
#define fk_app_NetworkInfo_fields &fk_app_NetworkInfo_msg
#define fk_app_NetworkSettings_fields &fk_app_NetworkSettings_msg
#define fk_app_Firmware_fields &fk_app_Firmware_msg
#define fk_app_Identity_fields &fk_app_Identity_msg
#define fk_app_ConfigureSensorQuery_fields &fk_app_ConfigureSensorQuery_msg
#define fk_app_LiveDataPoll_fields &fk_app_LiveDataPoll_msg
#define fk_app_LiveDataSample_fields &fk_app_LiveDataSample_msg
#define fk_app_LiveData_fields &fk_app_LiveData_msg
#define fk_app_File_fields &fk_app_File_msg
#define fk_app_Files_fields &fk_app_Files_msg
#define fk_app_DownloadFile_fields &fk_app_DownloadFile_msg
#define fk_app_EraseFile_fields &fk_app_EraseFile_msg
#define fk_app_FileData_fields &fk_app_FileData_msg
#define fk_app_DeviceStatus_fields &fk_app_DeviceStatus_msg
#define fk_app_QueryModule_fields &fk_app_QueryModule_msg
#define fk_app_ModuleReply_fields &fk_app_ModuleReply_msg
#define fk_app_WireMessageQuery_fields &fk_app_WireMessageQuery_msg
#define fk_app_Error_fields &fk_app_Error_msg
#define fk_app_WireMessageReply_fields &fk_app_WireMessageReply_msg
#define fk_app_Interval_fields &fk_app_Interval_msg
#define fk_app_Schedule_fields &fk_app_Schedule_msg
#define fk_app_Schedules_fields &fk_app_Schedules_msg
#define fk_app_HardwareStatus_fields &fk_app_HardwareStatus_msg
#define fk_app_GpsStatus_fields &fk_app_GpsStatus_msg
#define fk_app_MemoryStatus_fields &fk_app_MemoryStatus_msg
#define fk_app_BatteryStatus_fields &fk_app_BatteryStatus_msg
#define fk_app_SolarStatus_fields &fk_app_SolarStatus_msg
#define fk_app_PowerStatus_fields &fk_app_PowerStatus_msg
#define fk_app_Status_fields &fk_app_Status_msg
#define fk_app_Range_fields &fk_app_Range_msg
#define fk_app_DownloadQuery_fields &fk_app_DownloadQuery_msg
#define fk_app_Recording_fields &fk_app_Recording_msg
#define fk_app_LoraSettings_fields &fk_app_LoraSettings_msg
#define fk_app_Location_fields &fk_app_Location_msg
#define fk_app_WifiTransmission_fields &fk_app_WifiTransmission_msg
#define fk_app_Transmission_fields &fk_app_Transmission_msg
#define fk_app_ListDirectory_fields &fk_app_ListDirectory_msg
#define fk_app_HttpQuery_fields &fk_app_HttpQuery_msg
#define fk_app_DataStream_fields &fk_app_DataStream_msg
#define fk_app_LiveSensorReading_fields &fk_app_LiveSensorReading_msg
#define fk_app_LiveModuleReadings_fields &fk_app_LiveModuleReadings_msg
#define fk_app_LiveReadings_fields &fk_app_LiveReadings_msg
#define fk_app_DirectoryEntry_fields &fk_app_DirectoryEntry_msg
#define fk_app_DirectoryListing_fields &fk_app_DirectoryListing_msg
#define fk_app_NearbyNetwork_fields &fk_app_NearbyNetwork_msg
#define fk_app_NearbyNetworks_fields &fk_app_NearbyNetworks_msg
#define fk_app_HttpReply_fields &fk_app_HttpReply_msg
#define fk_app_ModuleHttpQuery_fields &fk_app_ModuleHttpQuery_msg
#define fk_app_ModuleHttpReply_fields &fk_app_ModuleHttpReply_msg
#define fk_app_UdpMessage_fields &fk_app_UdpMessage_msg

/* Maximum encoded size of messages (where known) */
/* fk_app_SensorCapabilities_size depends on runtime parameters */
/* fk_app_ModuleCapabilities_size depends on runtime parameters */
/* fk_app_Capabilities_size depends on runtime parameters */
/* fk_app_NetworkInfo_size depends on runtime parameters */
/* fk_app_NetworkSettings_size depends on runtime parameters */
/* fk_app_Firmware_size depends on runtime parameters */
/* fk_app_Identity_size depends on runtime parameters */
/* fk_app_LiveData_size depends on runtime parameters */
/* fk_app_File_size depends on runtime parameters */
/* fk_app_Files_size depends on runtime parameters */
/* fk_app_FileData_size depends on runtime parameters */
/* fk_app_QueryModule_size depends on runtime parameters */
/* fk_app_ModuleReply_size depends on runtime parameters */
/* fk_app_WireMessageQuery_size depends on runtime parameters */
/* fk_app_Error_size depends on runtime parameters */
/* fk_app_WireMessageReply_size depends on runtime parameters */
/* fk_app_Schedule_size depends on runtime parameters */
/* fk_app_Schedules_size depends on runtime parameters */
/* fk_app_MemoryStatus_size depends on runtime parameters */
/* fk_app_Status_size depends on runtime parameters */
/* fk_app_DownloadQuery_size depends on runtime parameters */
/* fk_app_LoraSettings_size depends on runtime parameters */
/* fk_app_WifiTransmission_size depends on runtime parameters */
/* fk_app_Transmission_size depends on runtime parameters */
/* fk_app_ListDirectory_size depends on runtime parameters */
/* fk_app_HttpQuery_size depends on runtime parameters */
/* fk_app_DataStream_size depends on runtime parameters */
/* fk_app_LiveSensorReading_size depends on runtime parameters */
/* fk_app_LiveModuleReadings_size depends on runtime parameters */
/* fk_app_LiveReadings_size depends on runtime parameters */
/* fk_app_DirectoryEntry_size depends on runtime parameters */
/* fk_app_DirectoryListing_size depends on runtime parameters */
/* fk_app_NearbyNetwork_size depends on runtime parameters */
/* fk_app_NearbyNetworks_size depends on runtime parameters */
/* fk_app_HttpReply_size depends on runtime parameters */
/* fk_app_ModuleHttpQuery_size depends on runtime parameters */
/* fk_app_ModuleHttpReply_size depends on runtime parameters */
/* fk_app_UdpMessage_size depends on runtime parameters */
#define fk_app_BatteryStatus_size                12
#define fk_app_ConfigureSensorQuery_size         12
#define fk_app_DeviceStatus_size                 28
#define fk_app_DownloadFile_size                 24
#define fk_app_EraseFile_size                    6
#define fk_app_GpsStatus_size                    44
#define fk_app_HardwareStatus_size               0
#define fk_app_Interval_size                     28
#define fk_app_LiveDataPoll_size                 6
#define fk_app_LiveDataSample_size               22
#define fk_app_LiveValue_size                    12
#define fk_app_Location_size                     23
#define fk_app_ModuleHeader_size                 18
#define fk_app_PowerStatus_size                  22
#define fk_app_QueryCapabilities_size            12
#define fk_app_Range_size                        12
#define fk_app_Recording_size                    40
#define fk_app_SolarStatus_size                  6

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
